<?php

declare(strict_types=1);
namespace Geeks4Change\GeekyDeploy\FileContent\Php;

abstract class PhpContentBase implements PhpContentInterface {

  protected static function addLine(array &$lines, PhpAssignment|string $line): void {
    if ($line instanceof PhpAssignment) {
      // Add assignments to array keyed by variable name.
      $variable = $line->getVariable();
      // Ensure that later assignments get appended, not overwritten.
      // @todo Replace the original assignment with a comment.
      unset($lines[$variable]);
      $lines[$variable] = $line;
    }
    else {
      // Add literal lines by integer key.
      $lines = array_merge($lines, explode("\n", $line));
    }
  }

  public function getContent(): string {
    return implode("\n", array_merge(
      [
        '<?php declare(strict_types=1);',
        '// Generated by GeekyDeploy.'
      ],
      $this->getLines(),
      ['']),
    );
  }

}
